<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on August 28, 2007 at 6:20:42 pm</time-stamp>
<!-- Changes from: PV-CME-Core(Green.8,hbolla)  to: PV-CME-Core(Green.9,mkamath) -->


<methods>
<class-id>PROVISO.PvCmeEngine</class-id> <category>processing (post-hourly)</category>

<body package="PV-CME-Core" selector="flushInternal">flushInternal

	| stateTempHourDirectory outputStream delay outputHourDirectory |
	stateTempHourDirectory := 
		self fileInterface 
			getDirectoryForHourTimestamp: self currentHour
			relativeTo: self fileInterface stateTempDirectory.
	outputStream :=
		PvHourlyAggAndRawStreamSet 
			newForHourDirectory: stateTempHourDirectory
			hour: self currentHour asHours
			prefix: ''
			compressFiles: self compressOutputFiles
			fileInterface: self fileInterface.
	outputStream pvModel: self pvModel.
	self
		flushRawBucketsOn: outputStream;
		flushRaBucketsOn: outputStream;
		flushGaBucketsOn: outputStream.

	outputHourDirectory := 
		self fileInterface outputHourDirectoryForHourTimestamp: self currentHour.

	delay := 
		self fileInterface doStateChange: 
			[outputStream
				createFileLinksInDirectory: self fileInterface stateTempDirectory;
				close.
			"Delete any RA and GA files we don't want to present to LDR right now"
			self deleteAnyRAAndGAFilesBeforePresentingToLDR: stateTempHourDirectory forHour: self currentHour.
			(outputHourDirectory exists and: [outputHourDirectory directoryContents isEmpty])
				ifTrue: [outputHourDirectory delete].
			stateTempHourDirectory renameTo: outputHourDirectory.
			self fileInterface
				writeLastHourFileTimestamp: self currentHour;	
				moveBaselinesFromTempToState;
				moveStateTempToStateCurrent;
				writeCloseHourFileForTimestamp: self currentHour].
	self stats incrementTimingFor: #postHourlyFlowControlSeconds by: delay</body>

<body package="PV-CME-Core" selector="deleteAnyRAAndGAFilesBeforePresentingToLDR:forHour:">deleteAnyRAAndGAFilesBeforePresentingToLDR: stateTempHourDirectory forHour: hourTimestamp

	"If they want low fideltiy they have to specifically ask for it"
	| fidelity |
	fidelity := 
		(self configuration 
			stringAt: 'AGGREGATION_FIDELITY'
			ifAbsent: ['HIGH']) asUppercase.
	fidelity = 'LOW'
		ifFalse: [^nil].

	"Let DRAs go thru to LDR every hour since DataView may not be able to handle 3 hr gaps very well"
	"(stateTempHourDirectory filenamesMatching: '*DRA.BOF')
		do: [:filename | | tz |
			tz := self pvModel calendarManager timezoneWithId: (filename tail readStream upToAll: '.') asNumber.
			(tz notNil and: [((tz localizeGMTHour: hourTimestamp asHours +1) \\ 3) = 0]) 
					ifFalse: [filename delete]]."

	"Only let WRAs go thru to LDR every 6 hrs"
	(stateTempHourDirectory filenamesMatching: '*WRA.BOF')
		do: [:filename | | tz |
			tz := self pvModel calendarManager timezoneWithId: (filename tail readStream upToAll: '.') asNumber.
			(tz notNil and: [((tz localizeGMTHour: hourTimestamp asHours +1) \\ 6) = 0]) 
					ifFalse: [filename delete]].
	"Only let MRAs go thru to LDR every 24 hrs"
	(stateTempHourDirectory filenamesMatching: '*MRA.BOF')
		do: [:filename | | tz |
			tz := self pvModel calendarManager timezoneWithId: (filename tail readStream upToAll: '.') asNumber.
			(tz notNil and: [((tz localizeGMTHour: hourTimestamp asHours +1) \\ 24) = 0]) 
					ifFalse: [filename delete]].

	"Let DGAs go thru to LDR every hour since DataView may not be able to handle 3 hr gaps very well"
	"(stateTempHourDirectory filenamesMatching: '*DGA.BOF')
		do: [:filename | | tz |
			tz := self pvModel calendarManager timezoneWithId: (filename tail readStream upToAll: '.') asNumber.
			(tz notNil and: [((tz localizeGMTHour: hourTimestamp asHours +1) \\ 3) = 0]) 
					ifFalse: [filename delete]]."
	(stateTempHourDirectory filenamesMatching: '*WGA.BOF')
		do: [:filename | | tz |
			tz := self pvModel calendarManager timezoneWithId: (filename tail readStream upToAll: '.') asNumber.
			(tz notNil and: [((tz localizeGMTHour: hourTimestamp asHours +1) \\ 6) = 0]) 
					ifFalse: [filename delete]].
	(stateTempHourDirectory filenamesMatching: '*MGA.BOF')
		do: [:filename | | tz |
			tz := self pvModel calendarManager timezoneWithId: (filename tail readStream upToAll: '.') asNumber.
			(tz notNil and: [((tz localizeGMTHour: hourTimestamp asHours +1) \\ 24) = 0]) 
					ifFalse: [filename delete]].</body>
</methods>


<methods>
<class-id>PROVISO.PvPeriodBasedStream</class-id> <category>api</category>

<body package="PV-CME-Core" selector="createFileLinksInDirectory:">createFileLinksInDirectory: aFilename 
	
	dayStream flush.
	weekStream flush.
	monthStream flush.

	dayStream stream fileName linkToNewFilename: 
		(aFilename construct: dayStream fileName tail).
	weekStream stream fileName linkToNewFilename: 
		(aFilename construct: weekStream fileName tail).
	monthStream stream fileName linkToNewFilename: 
		(aFilename construct: monthStream fileName tail)</body>
</methods>



</st-source>
